<template>
  <section class="extra-category" :class="{ 'extra-category--extras-hidden': !showExtras }">
    <header class="extra-category__header" @click="calcHeightAndToggle">
      <img
        class="extra-category__dropdown"
        src="../../assets/images/layout/angle-down-blue.svg"
        alt="dropdown"
      />
      <h2 class="extra-category__name">{{ name }}</h2>
      <span class="extra-category__optional-text">Opcional</span>
    </header>
    <!-- The below content visibility can be toggled by the user -->
    <div class="extras-list" :style="{ height: extrasListHeight }" ref="extrasList">
      <div class="extras-list__separator"></div>
      <div v-for="extra in extras" :key="extra.id">
        <Extra :extra="extra"></Extra>
        <!-- Separator divs used because in Edge and IE11 margins don't collapse when the section is folded -->
        <div class="extra__separator"></div>
      </div>
    </div>
  </section>
</template>

<script>
import { setTimeout } from 'timers';
import Extra from '@/components/ChooseExtras/Extra.vue';

export default {
  name: 'ExtraCategory',
  components: {
    Extra,
  },
  props: {
    name: String,
    extras: Array,
    startsUnfolded: Boolean,
  },
  data() {
    return {
      showExtras: this.startsUnfolded,
      // extrasList default height would be auto while unfolded.
      // The reason it can't have a permanent fixed height is that it has unfoldable sections inside.
      // We will make it have a fixed height later but only for the time needed to make the transitions happen
      // (css transitions can only take place between absolute values)
      extrasListHeight: this.startsUnfolded ? 'auto' : 0,
    };
  },
  methods: {
    calcHeightAndToggle() {
      if (!this.showExtras) {
        // before the hidden content unfolds:
        // make extrasList height equal to its scrollHeight,
        this.extrasListHeight = `${this.$refs.extrasList.scrollHeight}px`;
        // After the transition ends, height returns to auto.
        // Temporal fix: I'm using setTimeout because ontransitionend seems buggy on some browsers
        setTimeout(() => {
          this.extrasListHeight = 'auto';
        }, 500); // 500ms = 0.5s that the transition takes
      } else {
        // before the content folds:
        // set height to scrollHeight again so the transtion has a initial value
        this.extrasListHeight = `${this.$refs.extrasList.scrollHeight}px`;
        // after 100ms set it to 0, the ending transition value (requestAnimationframe is not enough for some browsers)
        setTimeout(() => {
          this.extrasListHeight = 0;
        }, 100);
      }
      this.showExtras = !this.showExtras;
    },
  },
};
</script>

<style lang="scss" scoped>
.extra-category {
  margin-top: 30px;
  padding: 0 10px 1px;
  overflow: hidden; // for really small resolutions
  background-color: white;
  box-shadow: $primary-box-shadow;

  @include for-tablet-up {
    padding: 0 30px 1px;
  }
}

.extra-category__header {
  display: flex;
  align-items: baseline;
  padding: 30px 0;
  cursor: pointer;
}

.extra-category__dropdown {
  margin-right: 1rem;
  transform: rotateX(180deg);
  transition: transform 0.5s;

  .extra-category--extras-hidden & {
    transform: rotateX(0);
  }
}

.extra-category__name {
  @include font-roboto-slab-bold(1.5rem, $primary-light);
  margin-right: 0.7em;
}

.extra-category__optional-text {
  @include font-roboto(0.75rem, $primary-medium);
}

.extras-list {
  // Height is set by the extrasHeight variable and calculated in calcHeightandToggle method
  transition: height 0.5s;
}

.extras-list__separator {
  height: 1px;
}

.extra__separator {
  height: 30px;
}
</style>
